/*
    lkpatch - a Linux Kernel Patcher

    Copyright 1999, 2000 Theo Nolte <nolte@post.rwth-aachen.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
*/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <sys/time.h>
#include <netinet/in.h>

#include "lkpatch.h"

char*dotquad(u32 ip) {
 static char s[50];
 int h=ntohl(ip),m=0xff;
  sprintf(s,"%d.%d.%d.%d",(h>>24)&m,(h>>16)&m,(h>>8)&m,h&m);
  return(s);
}

char*dotquad0(u32 ip) {
 static char s[50];
 int h=ntohl(ip),m=0xff;
  sprintf(s,"%03d.%03d.%03d.%03d",(h>>24)&m,(h>>16)&m,(h>>8)&m,h&m);
  return(s);
}

/*---------------------------DOWNLOAD-------------------------------*/

static char ebuf[URLGET_ERROR_SIZE];
static BUF*bbuf;
static long q;

size_t handle_data (void *ptr, size_t size, size_t nitems, FILE *stream) {
#if 0
  fprintf(stderr,"handle_data((void*),size=%d,nitems=%d,stream)\n",size,nitems);
#endif
  (void)stream;                   /* stop complaining using g++ -Wall */
  if ((int)nitems <= 0) {
     return (size_t)0;
  }
  addbuf(bbuf,ptr,size*nitems);
  return nitems;
}

long dlq(void) { return q; }
char*dlerr(void) { return(ebuf); }

int dlget(char*url,char*vhost,BUF*b,int to) {
 int rv,htag;
 long us;
 double bw;
 struct timeval t1,t2;
 struct HttpHeader chdr;
  dp(DTRC,"dlget: url: '%s', vhost: '%s'",url,vhost);
  bbuf=b;
  htag=URGTAG_DONE;
  if(vhost) {
    htag=URGTAG_HTTPHEADER;
    chdr.next=0;
    chdr.header=emalloc(strlen("host: ")+strlen(vhost)+1);
    sprintf(chdr.header,"host: %s",vhost);
  }
  if(gettimeofday(&t1,NULL)==-1) error(1,errno,"dlget: gettimeofday1");
  rv=curl_urlget(URGTAG_URL, url,
              URGTAG_FLAGS, CONF_NOPROGRESS | CONF_FAILONERROR,
              URGTAG_ERRORBUFFER, ebuf,
              URGTAG_WRITEFUNCTION,
                (size_t (*)(void *, int, int, FILE *))handle_data,
              URGTAG_LOW_SPEED_LIMIT,1,
              URGTAG_LOW_SPEED_TIME, to,
              htag, &chdr,
              URGTAG_DONE);
  if(gettimeofday(&t2,NULL)==-1) error(1,errno,"dlget: gettimeofday2");
  if(rv!=URG_OK) {
    dp(DTRC,"download failed: %s",ebuf);
    return(rv);
  }
  us=1e6*(t2.tv_sec-t1.tv_sec)+(t2.tv_usec-t1.tv_usec);
  bw=1.e6*(double)buflen(b)/(double)us;
  dp(DTRC,"dlget: %d byte, %ld usec, bw=%lf b/s, rv=%d",buflen(b),us,bw,rv);
  q=(long)bw;
  return(rv);
}
